#include <delay.h>
#include "sht10lib.h"
//******************************************************************//
void sht10_start(void)
{
    Data(1);
    Sck(0);
    Sck(1);
    Data(0);
    Sck(0);
    Sck(1);
    Data(1);
    Sck(0);
}
//******************************************************************//
char sht10_write(unsigned char Byte)
{ 
  unsigned char i, error = 0;
    delay_us(5);
    for(i = 0x80; i > 0; i>>=1)
     {
          Sck(0);
          delay_us(2);
          if(i & Byte)
          {
            Data(1);
          }
          else
          {
            Data(0);
          } 
          Sck(1);
          delay_us(2);
     } 
    Sck(0);
    Data(1);
    Sck(1);
    error = DataRead();
    Sck(0);
    return(error);
} 
//******************************************************************//
unsigned char sht10_readByte(unsigned char ack)
{
unsigned char i, val = 0;

    Data(1);//High input

    for(i = 0x80; i > 0; i /= 2)
    {
        Sck(1);
        delay_us(2);
        if(DataRead())
        {
        val = val | i;
        }
        Sck(0);
        delay_us(2);
    } 
    Data(!ack); 
    Sck(1);
    Sck(0);
    return(val);
}
//******************************************************************//
unsigned int sht10_ReadRegister(int Reg)
{
unsigned char msb, lsb, crc;
    sht10_start();
    sht10_write(Reg);
    while(DataRead());
    msb = sht10_readByte(1);
    lsb = sht10_readByte(1);
    crc = sht10_readByte(0);
    return(((unsigned short) msb << 8) | (unsigned short) lsb); 
}
//******************************************************************//
void sht10_ReadData(float *Temp , float *Hum)
{
  const float c1 = -4.0;   
  const float c2 = 0.0405;   
  const float c3 = -0.0000028;   
  const float t1 = 0.01;   
  const float t2 = 0.00008;   
     
  float rh =sht10_ReadRegister(MEASURE_HUMI);   
  float t = sht10_ReadRegister(MEASURE_TEMP);     
  float rh_lin;   
  float rh_true;   
  float t_c;   
     
  t_c = t * 0.01 - 39.6;   
  rh_lin = c3 * rh * rh + c2 * rh + c1;   
  rh_true = ( t_c - 25 ) * ( t1 + t2 * rh ) + rh_lin;   
  if (rh_true > 100)    rh_true = 100;   
  if (rh_true < 0.1)    rh_true = 0.1;   
     
  *Temp = t_c;   
  *Hum = rh_true;     
 return; 
}
//******************************************************************//
